Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class Form1
	Inherits System.Windows.Forms.Form
	'*********************************************************************************
    '   Visual Basic.NET GPIBkybd Program                                  03-15-16
    '   Copyright 2006 ICS Electronics div Systems West, Inc.
	'
	'   Program controls the GPIB-32.dll with NI-488.2 type calls
	'   Causes the 488-USB to continually query a device when the IDN loop is running
	'   Causes the 488-USB to repeat the Device Command when the Cmd loop is running
    ' 05-18-06  Converted to VB.NET
    ' 05-31-06  Added ibdev command to FindLstn
    ' 09-06-06  Added GPIB signal display, read terminators
    ' 09-08-06  Form load - deleted ibfind, put ibpad after SendIFC
    ' 10-31-06  Added test to find first available GPIBn Ctlr
    ' 01-15-07  Added Receive error checking to Timer1 routines
    ' 07-13-07  Fixed tab order 
    ' 06-06-08  Fixed AllSpoll to match Explorer
    ' 05-19-09  Fixed Send to always assert EOI
    ' 10-20-10  Removed Access DLL calls, Fixed Help
    ' 02-27-13  Display cr & lf terminators, expand Read buffer and added GTL button.
    ' 04-08-14  Updated for VB2010.
    ' 06-06-14  Added Local Lockout button.
	' **********************************************************************************
	Dim CmdStr As String
	Dim SPACE80S As String
    Dim OutFlag As Short
    Public NL As String
	Public Msg_Format As String
	Public Cmd As String
    Public FirstTimeFlg As Short
    Public Setpointoff As Short
	Public Ctlraddr As Short
    Public Device As Short     'ppss address form
    Public Er As Long
    Public bud As Long         'board descriptor
    Public ud As Long
    Public eos As Long
    Public vtmo As Long        'current Timeout Setting
    Public Testnum As Short
    Public IDNTestFlg As Short
    Public CMDloopFlg As Short
    Public LpCount As Long
    Public TestHalt As Short   'stops any test loop
    Public founddev As Long    'address of the first found device
    Public FoundFlg As Short   'flag indicates a device was found or address set
    Public FoundNum As Short   'number of found devices
    Dim Devlist(64) As Short    'list of found devices passed to AllSpoll
    Dim resplist(64) As Short
    Dim addrlist(32) As Short
    Dim alist(1) As Integer
    Dim v As Integer
    Dim Revdate As String = "03-15-2016"
    Public Firstflg As Short    'set until controller initialized

	Const winPictureBox As Integer = 2016002
	Const winCommandButton As Integer = 2007557
    Dim Outbuf As String
    Dim Inbuf As String
    
    Private Sub Form1_DoubleClick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.DoubleClick
        'Dim CommonDialog1 As Object
        'UPGRADE_WARNING: Couldn't resolve default property of object CommonDialog1.HelpFile. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
        'CommonDialog1.HelpFile = "C:\VB6\VBKybd\NI_GPIBkybd\GPIBkybd2.chm"
        'UPGRADE_WARNING: Couldn't resolve default property of object CommonDialog1.HelpCommand. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
        'CommonDialog1.HelpCommand = MSComDlg.HelpConstants.cdlHelpContents
        'UPGRADE_WARNING: Couldn't resolve default property of object CommonDialog1.ShowHelp. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
        'CommonDialog1.ShowHelp()
    End Sub

    Private Sub Tdelay(ByRef delaytime As Double)
        Dim starttime As Double
        starttime = VB.Timer()
        Do Until VB.Timer() >= starttime + delaytime
        Loop
    End Sub

    Public Sub GPIBSignals()    'updates GPIB bus signal display
        Dim clines As Integer
        lblEOI.Enabled = False : lblEOI.ForeColor = Color.Gray
        lblATN.Enabled = False : lblATN.ForeColor = Color.Gray
        lblSRQ.Enabled = False : lblSRQ.ForeColor = Color.Gray
        lblREN.Enabled = False : lblREN.ForeColor = Color.Gray
        lblIFC.Enabled = False : lblIFC.ForeColor = Color.Gray
        lblNRFD.Enabled = False : lblNRFD.ForeColor = Color.Gray
        lblNDAC.Enabled = False : lblNDAC.ForeColor = Color.Gray
        lblDAV.Enabled = False : lblDAV.ForeColor = Color.Gray
        Call GPIB32Funcs.iblines(bud, clines)
        If (clines And 32896) = 32896 Then lblEOI.Enabled = True : lblEOI.ForeColor = Color.DarkRed
        If (clines And 16448) = 16448 Then lblATN.Enabled = True : lblATN.ForeColor = Color.DarkRed
        If (clines And 8224) = 8224 Then lblSRQ.Enabled = True : lblSRQ.ForeColor = Color.DarkRed
        If (clines And 4112) = 4112 Then lblREN.Enabled = True : lblREN.ForeColor = Color.DarkRed
        If (clines And 2056) = 2056 Then lblIFC.Enabled = True : lblIFC.ForeColor = Color.DarkRed
        If (clines And 1028) = 1028 Then lblNRFD.Enabled = True : lblNRFD.ForeColor = Color.DarkRed
        If (clines And 514) = 514 Then lblNDAC.Enabled = True : lblNDAC.ForeColor = Color.DarkRed
        If (clines And 257) = 257 Then lblDAV.Enabled = True : lblDAV.ForeColor = Color.DarkRed
    End Sub

    'UPGRADE_WARNING: Event ckRen.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
    Private Sub ckRen_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ckRen.CheckStateChanged

        alist(1) = GPIB32Funcs.NOADDR

        If ckRen.CheckState = 1 Then
            v = 1
            Call GPIB32Funcs.ibsre(bud, v)
            txtResults.Text = "REN Asserted"
        Else
            v = 0
            Call GPIB32Funcs.ibsre(bud, v)
            txtResults.Text = "REN deasserted"
        End If
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("ibsre Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
        End If
        Call GPIBSignals()
    End Sub

    Private Sub cmdAllPoll_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdAllPoll.Click
        Dim I As Short
        Dim flist As String
        Dim SC As String

        SC = ""
        combCmd.Text = ""
         If FoundFlg = 0 Then
            txtResults.Text = "No devices found. Use Findlstn or enter and set a device address"
            txtError.Visible = False
            Beep()
            GoTo APexit
        End If
        If Devlist(0) = GPIB32Funcs.NOADDR Then
            txtResults.Text = "Device list empty. Use Findlstn to create a device list"
            txtError.Visible = False
            Beep()
            GoTo APexit
        End If

        txtResults.Text = "All Serial Poll: Polling All devices"
        Call GPIB32Funcs.ibtmo(bud, GPIB32Funcs.T100ms)     'shorten timeout for serial polling all devices

        Call GPIB32Funcs.AllSpoll(BD, Devlist, resplist)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("AllSpoll error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            flist = ""
            If FoundNum > 1 Then
                For I = 0 To (FoundNum - 1)
                    flist = flist & SC & "Inst" & Str(Devlist(I)) & "," & Str(resplist(I))
                    SC = "; "
                Next I
                txtResults.Text = "All Serial Poll: Responses = " & flist
            ElseIf (FoundNum = 1) Then
                flist = "Inst" & Str(Devlist(0)) & "," & Str(resplist(0))
                txtResults.Text = "All Serial Poll: Response = " & flist
            Else
                Beep()
                txtResults.Text = "All Serial Poll: No responses returned"
            End If
        End If
        Call GPIB32Funcs.ibtmo(bud, vtmo)           'restore timout to user setting
APexit: Call GPIBSignals()
    End Sub

    Private Sub cmdCLS_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs)
        Dim eotmode As Short
        Dim Outstring As String
        txtError.Visible = False
        If FoundFlg = 0 Then
            txtResults.Text = "No devices found. Use Findlstn or enter and set a device address"
            txtError.Visible = False
            Beep()
            GoTo CLSexit
        End If
        Outstring = "*CLS"                  'clear ESR and status registers
        txtResults.Text = ""
        combCmd.Text = ""
        If ckCR.CheckState = 1 Then Outstring = Outstring & Chr(13)
        If ckLF.CheckState = 1 Then Outstring = Outstring & Chr(10)
        eotmode = GPIB32Funcs.DABend
        Call GPIB32Funcs.Send(BD, addr, Outstring, eotmode)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("Send error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "*CLS sent to device" & Str(Device)
        End If
CLSexit: Call GPIBSignals()
    End Sub

    Private Sub cmdCmdtst_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCmdtst.Click
        If combCmd.Text = "" Then
            Beep()
            txtResults.Text = "No command specified.  Enter a command before starting the Command Loop"
        Else
            CMDloopFlg = 1
            TestHalt = 0
            cmdCmdtst.Enabled = False
            cmdCmdtstoff.Enabled = True
        End If
        Call GPIBSignals()
    End Sub

    Private Sub cmdCMDtstoff_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCmdtstoff.Click
        CMDloopFlg = 0
        cmdCmdtst.Enabled = True
        cmdCmdtstoff.Enabled = False
        If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
            txtCount.Visible = False
            lblCount.Visible = False
            LpCount = 0
            TestHalt = 0
        End If
        Call GPIBSignals()
    End Sub

    Private Sub cmdDevClr_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdDevClr.Click
        txtError.Visible = False
        If FoundFlg = 0 Then
            txtResults.Text = "No devices found. Use Findlstn or enter and set a device address"
            txtError.Visible = False
            Beep()
            GoTo Devclrexit
        End If
        combCmd.Text = ""
        Call GPIB32Funcs.DevClear(BD, addr)         'selected device clear
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("DevCLr Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "Selected Device Clear sent to device" & Str(Device)
        End If
Devclrexit: Call GPIBSignals()
    End Sub

    Private Sub cmdExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdExit.Click
        End
    End Sub

    Private Sub cmdFindLstn_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdFindLstn.Click
        Dim flist As String
        Dim ppss As Short
        Dim pad As Short
        Dim sad As Short
        Dim I As Short
        Dim foundaddr As Short
        Dim limit As Short
        txtError.Visible = False
        combCmd.Text = ""
        flist = ""
        limit = 32
        foundaddr = 0
        txtResults.Text = "FindLstn: Wait while looking for devices"
        txtResults.Refresh()
        If Ctlraddr = 0 Then
            For I = 0 To 29                 'default list 1-30
                addrlist(I) = (I + 1)
            Next I
        Else
            For I = 0 To (Ctlraddr - 1)     'non zero controller address
                addrlist(I) = I
            Next I
            For I = (Ctlraddr) To 29
                addrlist(I) = I + 1
            Next I
        End If
        addrlist(30) = GPIB32Funcs.NOADDR       'terminates Addrlist

        Call GPIB32Funcs.FindLstn(BD, addrlist, Devlist, limit)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then 'added EBUS and ETAB tests 8-20-04
            If (GPIB32Funcs.iberr And GPIB32Funcs.EBUS = GPIB32Funcs.EBUS) Or (GPIB32Funcs.iberr And GPIB32Funcs.ETAB = GPIB32Funcs.ETAB) Then GoTo FLelse
            Call gpiberr("FindLstn error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
FLelse:     flist = ""
            For I = 0 To (GPIB32Funcs.ibcnt - 1)
                If Devlist(I) > 24576 Then      'secondary addresses conversion to ppss format
                    sad = Int((Devlist(I)) / 256)
                    pad = Devlist(I) - ((sad) * 256)
                    ppss = (pad * 100) + (sad - 96)
                    flist = flist & Str(ppss) & " "
                    If I = 0 Then
                        founddev = ppss
                        foundaddr = Devlist(I)
                        FoundFlg = 1
                    End If
                Else                        'primary addresses
                    flist = flist & Str(Devlist(I)) & " "
                    If I = 0 Then
                        founddev = Devlist(I)
                        foundaddr = Devlist(I)
                        FoundFlg = 1
                    End If
                End If
                FoundNum = (GPIB32Funcs.ibcnt)
            Next I
            Select Case GPIB32Funcs.ibcnt
                Case Is > 63
                    Beep()
                    txtError.Text = "Found " & Str(FoundNum) & " devices, check system and retry"
                    txtError.Visible = True
                    txtResults.Text = "FindLstn: Found" & Str(GPIB32Funcs.ibcnt) & " devices at addresses = " & flist
                    txtResults.Text = txtResults.Text + NL + "CAUTION - Not all found devices listed - Check system and retry."
                    'GoTo FLexit:
                Case Is > 1
                    txtResults.Text = "FindLstn: Found" & Str(GPIB32Funcs.ibcnt) & " devices at addresses = " & flist
                    txtResults.Text = txtResults.Text + NL + "Multiple devices found!" + NL + "Enter the correct device address and press the SET button."
                Case 1
                    txtResults.Text = "FindLstn: Found" & Str(GPIB32Funcs.ibcnt) & " device at address = " & flist
                    ud = GPIB32Funcs.ibdev(BD, pad, sad, vtmo, 1, eos, ud)
                Case 0
                    Beep()
                    txtResults.Text = "FindLstn: No devices found"
                    FoundFlg = 0
                    founddev = 0
                Case Else
                    Beep()
                    txtResults.Text = CStr("FindLstn: Undetermined results - GPIB32Funcs.ibcnt = " = Str(GPIB32Funcs.ibcnt))
                    FoundFlg = 0
                    founddev = 0
            End Select
            Devlist(FoundNum) = GPIB32Funcs.NOADDR
        End If
        txtAddr.Text = Str(founddev)
        addr = foundaddr                    'set found address to devlist(0)
FLexit: Call GPIBSignals()
    End Sub

    Private Sub cmdFindRQS_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdFindRQS.Click
        Dim result As Short
        Dim srq As Short
        txtError.Visible = False
        If FoundFlg = 0 Then
            txtResults.Text = "No devices found. Use Findlstn or enter and set a device address"
            txtError.Visible = False
            Beep()
            GoTo FRQSexit
        End If
        If Devlist(0) = GPIB32Funcs.NOADDR Then
            txtResults.Text = "Device list empty. Use Findlstn to create a device list"
            txtError.Visible = False
            Beep()
            GoTo FRQSexit
        End If

        Call GPIB32Funcs.TestSRQ(BD, srq)
        If srq = 0 Then
            Beep()
            txtResults.Text = "FindRQS: SRQ not asserted - no devices polled"
        Else
            Call GPIB32Funcs.ibtmo(bud, GPIB32Funcs.T100ms) 'shorten timeout for serial polling all devices
            If FoundNum = 0 Then
                txtResults.Text = "FindRQS:No found devices to be polled"
            Else
                txtResults.Text = "FindRQS:Wait while polling devices"
                txtResults.Refresh()
                GPIB32Funcs.ibcnt = 0
                Call GPIB32Funcs.FindRQS(BD, Devlist, result)
                If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
                    Call gpiberr("FindRQS Error")
                    txtError.Text = RetMsg
                    txtError.Visible = True
                    txtResults.Text = ""
                Else
                    txtResults.Text = "FindRQS: Device found at address " & Str(Devlist(GPIB32Funcs.ibcnt)) & " with SPoll response = " & Str(result)
                End If
            End If
            Call GPIB32Funcs.ibtmo(bud, vtmo)       'restore user timeout
        End If
FRQSexit: Call GPIBSignals()
    End Sub

    Private Sub cmdHelp_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdHelp.Click
        Dim StartupPath As String
        
        StartupPath = (System.Windows.Forms.Application.StartupPath)
        System.Diagnostics.Process.Start(StartupPath & "\GPIBkybd.chm")
    End Sub

    Private Sub cmdIDNtst_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdIDNtst.Click
        combCmd.Text = "*idn?"
        IDNTestFlg = 1
        TestHalt = 0
        cmdIDNtst.Enabled = False
        cmdIDNtstoff.Enabled = True
    End Sub

    Private Sub cmdIDNtstoff_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdIDNtstoff.Click
        IDNTestFlg = 0
        cmdIDNtst.Enabled = True
        cmdIDNtstoff.Enabled = False
        If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
            txtCount.Visible = False
            lblCount.Visible = False
            LpCount = 0
            TestHalt = 0
        End If
        Call GPIBSignals()
    End Sub

    Private Sub cmdIFC_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdIFC.Click
        Dim v As Short
        txtError.Visible = False
        combCmd.Text = ""
        Call GPIB32Funcs.SendIFC(BD)                'pulse IFC
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("SendIFC Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "Interface Clear sent"
            v = ckRen.CheckState
            Call GPIB32Funcs.ibsre(bud, v)      'assert REN if turned off
        End If
        IDNTestFlg = 0
        cmdIDNtst.Enabled = True
        cmdIDNtstoff.Enabled = False
        CMDloopFlg = 0
        cmdCmdtst.Enabled = True
        cmdCmdtstoff.Enabled = False
        txtCount.Visible = False
        lblCount.Visible = False
        Call GPIBSignals()
    End Sub

    Private Sub cmdIOloop_Click()
         CMDloopFlg = 1
    End Sub

    Private Sub cmdIOloopoff_Click()
        CMDloopFlg = 0
        If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
            txtCount.Visible = False
            lblCount.Visible = False
            LpCount = 0
        End If
        Call GPIBSignals()
    End Sub


    Private Sub cmdRead_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdRead.Click
        Dim N As Short
        Dim L As Short
        Dim Instring As String
        Dim term As Short
        Dim Nullflg As Short
        Dim LN As Short

        If FoundFlg = 0 Then
            txtResults.Text = "No devices found. Use Findlstn or enter and set a device address"
            txtError.Visible = False
            Beep()
            GoTo Readexit
        End If
        txtError.Visible = False
        Nullflg = 0
        term = GPIB32Funcs.STOPend
        If ckCRTerm.CheckState = 1 Then
            term = 13                           'set termination for CR or EOI
        ElseIf ckLFTerm.CheckState = 1 Then
            term = 10                           'set termination for LF or EOI
        End If
        Instring = Space(256)
        Call GPIB32Funcs.Receive(BD, addr, Instring, term)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("Receive Error")
            txtError.Text = RetMsg
            txtError.Visible = True
            TestHalt = 1
        Else
            If InStr(Instring, Chr(0)) <> 0 Then    'convert nulls to astrisks
                Do Until InStr(Instring, Chr(0)) = 0
                    L = Len(Instring)
                    N = InStr(Instring, Chr(0))
                    Instring = VB.Left(Instring, N - 1) & Chr(42) & VB.Right(Instring, L - N)
                    Nullflg = 1
                Loop
            End If
            If ckDispAll.CheckState = 0 Then
                L = InStr(Instring, Chr(13))        'check for CR
                If L <> 0 Then
                    Instring = VB.Left(Instring, L - 1)
                Else
                    L = InStr(Instring, Chr(10))     'check for LF
                     If L <> 0 Then
                         Instring = VB.Left(Instring, L - 1)
                    End If
                End If
            Else
                LN = Len(Instring$)
                Do Until InStr(Instring$, Chr(13)) = 0     'replace CR loop
                    N = InStr(Instring$, Chr(13))
                    If N = 1 Then
                        Instring$ = "<cr>" + VB.Right(Instring$, LN - N)      'replace first char
                    Else
                        Instring$ = VB.Left(Instring$, N - 1) + "<cr>" + VB.Right(Instring$, LN - N) 'replace any other char
                    End If
                Loop
                LN = Len(Instring$)
                Do Until InStr(Instring$, Chr(10)) = 0     'replace LF loop
                    N = InStr(Instring$, Chr(10))
                    If N = 1 Then
                        Instring$ = "<lf>" + VB.Right(Instring$, LN - N)      'replace first char
                    Else
                        Instring$ = VB.Left(Instring$, N - 1) + "<lf>" + VB.Right(Instring$, LN - N) 'replace any other char
                    End If
                Loop
            End If
            txtError.Visible = False
            txtResults.Text = RTrim(Instring)
            If ckByteCnt.CheckState = 1 Then
                txtResults.Text = txtResults.Text + NL + "Byte count= " + Str(GPIB32Funcs.ibcntl)
             End If
            If Nullflg Then
                txtResults.Text = txtResults.Text + NL + "Null found and converted to '*'"
            End If
        End If
Readexit: Call GPIBSignals()
    End Sub

    Private Sub cmdRST_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdRST.Click
        Dim eotmode As Short
        Dim Outstring As String
        txtError.Visible = False
        If FoundFlg = 0 Then
            txtResults.Text = "No devices found. Use Findlstn or enter and set a device address"
            txtError.Visible = False
            Beep()
            GoTo RSTexit
        End If
        Outstring = "*RST"              'reset unit to power on settings
        txtResults.Text = ""
        combCmd.Text = ""
        If ckCR.CheckState = 1 Then Outstring = Outstring & Chr(13)
        If ckLF.CheckState = 1 Then Outstring = Outstring & Chr(10)
        eotmode = GPIB32Funcs.DABend

        Call GPIB32Funcs.Send(BD, addr, Outstring, eotmode)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("Send error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "*RST sent to device" & Str(Device)
        End If
RSTexit: Call GPIBSignals()
    End Sub

    Private Sub cmdSend_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSend.Click
        Dim eotmode As Short
        Dim Outstring As String                 'send command string
        txtError.Visible = False
        Outstring = combCmd.Text
        txtResults.Text = ""
        If FoundFlg = 0 Then
            txtResults.Text = "No devices found. Use Findlstn or enter and set a device address"
            txtError.Visible = False
            Beep()
            GoTo Sendexit
        End If
        If ckCR.CheckState = 1 Then Outstring = Outstring & Chr(13)
        If ckLF.CheckState = 1 Then Outstring = Outstring & Chr(10)
        eotmode = GPIB32Funcs.DABend

        Call GPIB32Funcs.Send(BD, addr, Outstring, eotmode)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("Send error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            If (ckAutoQuery.CheckState = 1) And (InStr(Outstring, "?") <> 0) Then
                Call cmdRead_Click(cmdRead, New System.EventArgs())
            Else
                txtResults.Text = "Send String => " & Outstring
            End If
        End If
Sendexit: Call GPIBSignals()
    End Sub

    Private Sub cmdSet_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSet.Click
        Dim ln As Short
        Dim sad As Short
        Dim pad As Short
        Dim L As Short
        Dim Newaddr As Short
        txtError.Visible = False
        Newaddr = Val(txtAddr.Text)
        If Newaddr <> Ctlraddr Then
            FoundFlg = 0
            If (Newaddr >= 100) And (Newaddr <= 3030) Then
                If ud <> 0 Then
                    Call GPIB32Funcs.ibonl(ud, 0)       'disable existing device
                End If
                L = Len(txtAddr.Text)                   'get new device number-primary address
                 If L = 3 Then
                    pad = Val(VB.Left(txtAddr.Text, 1))
                    sad = Val(Mid(txtAddr.Text, 2, 2)) + 96
                    addr = ((sad) * 256) + pad          'combined NI ppss data address
                 ElseIf L = 4 Then
                    pad = Val(VB.Left(txtAddr.Text, 2))
                    sad = Val(Mid(txtAddr.Text, 3, 2)) + 96
                    addr = ((sad) * 256) + pad          'combined NI ppss data address
                Else
                    txtError.Text = "Length of address is out of range, reenter"
                    txtError.Visible = True
                    GoTo Sexit                          'secondary addr error exit
                End If

            ElseIf (Newaddr >= 0) And (Newaddr <= 30) Then
                If ud <> 0 Then
                    Call GPIB32Funcs.ibonl(ud, 0)       'disable existing device
                End If
                pad = Val(txtAddr.Text)
                sad = 0
                addr = pad                              'NI pp address value
            Else
                Beep()
                txtResults.Text = "Device Address outside of 0 to 30 or 100 to 3030 range, please reenter"
                GoTo Sexit                              'primary addr error exit
            End If
            Device = Val(txtAddr.Text)                  'process address
            Call GPIB32Funcs.ibdev(BD, pad, sad, vtmo, 1, eos, ud)
            Call GPIB32Funcs.ibln(ud, pad, sad, ln)     'check device presence
            If ln = 0 Then
                txtResults.Text = "Device not present at address " & Str(Device) & ".  Check device address and retry"
                Beep()
                GoTo Sexit
            End If
            dev = pad
            txtResults.Text = "Device Address => " & Str(Device)
            FoundFlg = 1                            'set device found flag
            founddev = Device
        Else
            Beep()
            txtResults.Text = "New Device address same as Controller's address,  please reenter"
        End If
Sexit:  combCmd.Text = ""
        Call GPIBSignals()
    End Sub

    Private Sub cmdSetCtlr_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSetCtlr.Click
        Dim Newaddr As Short
        Newaddr = Val(txtCtlrAddr.Text)
        combCmd.Text = ""
        txtError.Visible = False
        txtResults.Text = ""
        If (Newaddr >= 0) And (Newaddr <= 30) Then
            Ctlraddr = Val(txtCtlrAddr.Text)
            Call GPIB32Funcs.ibpad(bud, Ctlraddr)
            If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then    'set controller address
                Call gpiberr("ibpad error")
                txtError.Text = RetMsg
                txtError.Visible = True
            Else
                txtResults.Text = "Controller Address => " & txtCtlrAddr.Text
                Call GPIB32Funcs.SendIFC(BD)
            End If
        Else
            Beep()
            txtResults.Text = "Improper value for the Controller Address, please reenter"
        End If
        Call GPIBSignals()
    End Sub

    Private Sub cmdSPoll_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSPoll.Click
        Dim spresp As Short
        txtError.Visible = False
        If FoundFlg = 0 Then
            txtResults.Text = "No devices found. Use Findlstn or enter and set a device address"
            txtError.Visible = False
            Beep()
            GoTo SPexit
        End If
        combCmd.Text = ""
        Call GPIB32Funcs.ReadStatusByte(BD, addr, spresp)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("SPoll Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "Serial poll response for device" & Str(Device) & " = " & Str(spresp)
        End If
SPexit: Call GPIBSignals()
    End Sub

    Private Sub cmdTrig_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdTrig.Click
        txtError.Visible = False
        combCmd.Text = ""
        If FoundFlg = 0 Then
            txtResults.Text = "No devices found. Use Findlstn or enter and set a device address"
            txtError.Visible = False
            Beep()
            GoTo Trigexit
        End If
        Call GPIB32Funcs.Trigger(BD, addr)              'selected device clear
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("Trigger Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "GET sent to device" & Str(Device)
        End If
Trigexit: Call GPIBSignals()
    End Sub

    Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Dim I As Short
        Dim v As Short
        Dim ErrFlag As Short
        Dim TypeVar As String
        Dim NewName$

        'UPGRADE_ISSUE: App property App.HelpFile was not upgraded. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="076C26E5-B7A9-4E77-B69C-B4448DF39E58"'
        'App.HelpFile = "Gpibkybd.hlp"
        'text1.HelpContextID = winPictureBox
        'UPGRADE_ISSUE: Form property Form1.HelpContextID was not upgraded. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="CC4C7EC0-C903-48FC-ACCC-81861D12DA4A"'
        'Me.HelpContextID = winCommandButton
        cmdSetCtlr.Enabled = False
        cmdSet.Enabled = False
        cmdSend.Enabled = False
        cmdRead.Enabled = False
        cmdIDNtst.Enabled = False
        cmdIDNtstoff.Enabled = False
        cmdCmdtst.Enabled = False
        cmdCmdtstoff.Enabled = False
        cmdIFC.Enabled = False
        cmdDevClr.Enabled = False
        cmdTrig.Enabled = False
        cmdDevClr.Enabled = False
        cmdSPoll.Enabled = False
        cmdFindLstn.Enabled = False
        cmdFindRQS.Enabled = False
        cmdAllPoll.Enabled = False
        cmdRST.Enabled = False
        cmdGTL.Enabled = False
        cmdLLO.Enabled = False
        'cmdCLS.Enabled = False
        frmTimeout.Enabled = False
        SPACE80S = Space(100)       '100 spaces
        NL = Chr(13) & Chr(10)
        txtRev.Text = "Revised N13 " + Revdate
        txtError.Text = ""          'clear label and text box
        txtResults.Text = ""
        combCmd.Text = ""
        TypeVar = "GPIB"           'default to GPIB control
        For I = 0 To 15            'setup combox Interface names  GPIBn
            combCtlrName.Items.Add("GPIB" & LTrim$(Str$(I)))
        Next I
        ' Removed find first GPIB Ctlr 10-20-10 to not call the access DLL
        'Find first GPIB Controller         
        'Call AccessFuncs.Ibload()
        'If AccessFuncs.Ibsta And GPIB32Funcs.EERR Then      'if GPIBDIR missing
        'If AccessFuncs.Iberr = AccessFuncs.EDIR Then
        'MessageBox.Show("Reinstall the GPIB Driver", "Unable to find GPIBDIR variable", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        'End                                             'exit
        'End If
        'Else
        Firstflg = 1
        For I = 0 To 15                                 'else test for first physical GPIB controller
            NewName$ = "GPIB" + LTrim(Str$(I))          'make BD name
            BD = I
            bud = BD
            Call GPIB32Funcs.ibfind(NewName$, bud)         'test for GPIB Ctlr                 'get board descriptor
            If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then

            Else
                combCtlrName.SelectedIndex = I
                Exit For
            End If
        Next I

        ' combCtlrName.SelectedIndex = 0
        OutFlag = 0                 'define initial values
        FoundFlg = 0
        'BD = 0
        dev = 4
        'bddev = 0
        addr = 4
        Device = 4
        eos = 10
        txtAddr.Text = ""
        txtCtlrAddr.Text = "0"
        Testnum = 100
        IDNTestFlg = 0
        CMDloopFlg = 0
        txtCount.Visible = False
        LpCount = 0
        cmdExit.Enabled = True
        ckCR.CheckState = System.Windows.Forms.CheckState.Unchecked
        ckLF.CheckState = System.Windows.Forms.CheckState.Checked
        ckRen.CheckState = System.Windows.Forms.CheckState.Checked
        ckAutoQuery.CheckState = System.Windows.Forms.CheckState.Checked
        ckByteCnt.CheckState = System.Windows.Forms.CheckState.Unchecked
        ckLFTerm.CheckState = System.Windows.Forms.CheckState.Checked
        ckCRTerm.CheckState = System.Windows.Forms.CheckState.Unchecked
        txtResults.Enabled = True
        txtError.Enabled = False
        lblEOI.Enabled = False
        lblATN.Enabled = False
        lblSRQ.Enabled = False
        lblREN.Enabled = False
        lblIFC.Enabled = False
        lblNRFD.Enabled = False
        lblNDAC.Enabled = False
        lblDAV.Enabled = False
        ErrFlag = 0
        IDNTestFlg = 0
        CMDloopFlg = 0
        combCmd.Items.Insert(0, "*esr?")
        combCmd.Items.Insert(1, "*idn?")
        combCmd.Items.Insert(2, "*stb?")

        'GPIB Controller initialization
        Call GPIB32Funcs.SendIFC(BD)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then    'become CIC
            Call gpiberr("SendIFC error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            bud = BD                                        'use Bd id instead of getting a handle
            Ctlraddr = Val(txtCtlrAddr.Text)
            Call GPIB32Funcs.ibpad(bud, Ctlraddr)
            If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then    'set controller address
                Call gpiberr("ibpad error")
                txtError.Text = RetMsg
                txtError.Visible = True
            Else
                txtError.Visible = False
                v = 1
                Call GPIB32Funcs.ibsre(bud, v)              'assert REN
                If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
                    Call gpiberr("ibsre Error")
                    txtError.Text = RetMsg
                    txtError.Visible = True
                Else
                    ckRen.CheckState = System.Windows.Forms.CheckState.Checked
                    txtError.Visible = False
                    frmTimeout.Enabled = True
                    vtmo = GPIB32Funcs.T3s          'defautl to 3 second timeout
                    RadioButton4.Checked = True       'calls tmo
                    If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
                        Call gpiberr("ibtmo Error")
                        txtError.Text = RetMsg
                        txtError.Visible = True
                    Else
                        Call cmdFindLstn_Click(cmdFindLstn, New System.EventArgs()) 'find devices
                        If FoundFlg = 1 Then
                            dev = founddev 'get found device number
                            addr = founddev
                            Device = founddev
                            txtAddr.Text = Device
                        End If
                        cmdSetCtlr.Enabled = True
                        cmdSet.Enabled = True
                        cmdSend.Enabled = True
                        cmdRead.Enabled = True
                        cmdIDNtst.Enabled = True
                        cmdCmdtst.Enabled = True
                        cmdIFC.Enabled = True
                        cmdDevClr.Enabled = True
                        cmdTrig.Enabled = True
                        cmdDevClr.Enabled = True
                        cmdSPoll.Enabled = True
                        cmdFindLstn.Enabled = True
                        cmdFindRQS.Enabled = True
                        cmdAllPoll.Enabled = True
                        cmdRST.Enabled = True
                        cmdGTL.Enabled = True
                        cmdLLO.Enabled = True
                        ' cmdCLS.Enabled = True
                        FirstTimeFlg = 1
                    End If
                End If
            End If
        End If
        ' End If

        'UPGRADE_ISSUE: App property App.HelpFile was not upgraded. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="076C26E5-B7A9-4E77-B69C-B4448DF39E58"'
        'App.HelpFile = My.Application.Info.DirectoryPath & "\GPIBkybd2.chm"
        Me.HelpProvider1.SetHelpString(Me.cmdHelp, "Press here for help")
        Me.HelpProvider1.SetShowHelp(Me.cmdHelp, True)
        Me.HelpButton = True
        Call GPIBSignals()
    End Sub

    Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
        Dim eotmode As Short
        Dim Outstring As String
        If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
            txtCount.Visible = False
             LpCount = 0
            GoTo Timerexit
        End If
        If TestHalt = 1 Then GoTo Timerexit
        txtError.Visible = False

        If IDNTestFlg = 1 Then
            'combCmd.Text = ""
            Outstring = "*IDN?"
            If ckCR.CheckState = 1 Then Outstring = Outstring & Chr(13)
            If ckLF.CheckState = 1 Then Outstring = Outstring & Chr(10)
            eotmode = GPIB32Funcs.DABend
            Call GPIB32Funcs.Send(BD, addr, Outstring, eotmode)
            If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
                Call gpiberr("Send error")
                txtError.Text = RetMsg
                txtError.Visible = True
                 TestHalt = 1
            Else
                Call cmdRead_Click(cmdRead, New System.EventArgs())
                If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
                    Call gpiberr("Receive error")
                    txtError.Text = RetMsg
                    txtError.Visible = True
                    TestHalt = 1
                End If
            End If
        End If

        If CMDloopFlg = 1 Then      'loop using the string in the combCmd.text
            If combCmd.Text = "" Then
                Beep()
                txtError.Text = "Command box empty"
                txtError.Visible = True
            Else
                Outstring = combCmd.Text
                If ckCR.CheckState = 1 Then Outstring = Outstring & Chr(13)
                If ckLF.CheckState = 1 Then Outstring = Outstring & Chr(10)
                eotmode = GPIB32Funcs.DABend
                Call GPIB32Funcs.Send(BD, addr, Outstring, eotmode)
                If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
                    Call gpiberr("Send error")
                    txtError.Text = RetMsg
                    txtError.Visible = True
                    TestHalt = 1
                Else
                    If (ckAutoQuery.CheckState = 1) And (InStr(Outstring, "?") <> 0) Then
                        Call cmdRead_Click(cmdRead, New System.EventArgs())
                        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
                            Call gpiberr("Receive error")
                            txtError.Text = RetMsg
                            txtError.Visible = True
                            TestHalt = 1
                        End If
                    Else
                        txtResults.Text = "Sent string => " & Outstring
                    End If
                End If
            End If
        End If

Timerexit1: txtCount.Visible = True
        lblCount.Visible = True
        LpCount = LpCount + 1
        txtCount.Text = LpCount
        Call GPIBSignals()
Timerexit:
    End Sub

    'UPGRADE_WARNING: Event txtAddr.TextChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
    Private Sub txtAddr_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtAddr.TextChanged
        cmdSet.Enabled = True
    End Sub

    Private Sub combCmd_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles combCmd.KeyPress
        Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
        If KeyAscii = (13) Then
            Call cmdSend_Click(cmdSend, New System.EventArgs())
        End If
        eventArgs.KeyChar = Chr(KeyAscii)
        If KeyAscii = 0 Then
            eventArgs.Handled = True
        End If
    End Sub

    Private Sub ckLF_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckLF.CheckedChanged
        If ckLF.CheckState = CheckState.Checked Then
            ckCR.CheckState = CheckState.Unchecked
        End If
    End Sub

    Private Sub ckCR_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckCR.CheckedChanged
        If ckCR.CheckState = CheckState.Checked Then
            ckLF.CheckState = CheckState.Unchecked
        End If
    End Sub

    Private Sub ckCRTerm_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckCRTerm.CheckedChanged
        If ckCRTerm.CheckState = CheckState.Checked Then
            ckLFTerm.CheckState = CheckState.Unchecked
        End If
    End Sub

    Private Sub ckLFTerm_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckLFTerm.CheckedChanged
        If ckLFTerm.CheckState = CheckState.Checked Then
            ckCRTerm.CheckState = CheckState.Unchecked
        End If
    End Sub

    Private Sub combCtlrName_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combCtlrName.SelectedIndexChanged
        Dim NewName$
        Dim NewBDnum As Integer

        NewName$ = combCtlrName.SelectedItem        'get new BD name and number
        NewBDnum = Val(Mid$(NewName$, 5, 2))
        'If BD <> NewBDnum Or Firstflg = 1 Then 
        If BD <> NewBDnum Then                      'if new BD, initialize it
            BD = NewBDnum
            bud = BD
            Call GPIB32Funcs.ibfind(NewName$, bud)         'find next GPIBCtlr                     'get board descriptor
            If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
                Call gpiberr("ibfind error")
                txtError.Text = RetMsg
                txtError.Visible = True
                txtResults.Text = "Selected GPIB Controller not found" + NL
                txtResults.Text = txtResults.Text + "Select another Controller Name"
            Else
                'GPIB Controller initialization
                Call GPIB32Funcs.SendIFC(BD)
                If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then    'become CIC
                    Call gpiberr("SendIFC error")
                    txtError.Text = RetMsg
                    txtError.Visible = True
                Else
                    bud = BD                                        'use Bd id instead of getting a handle
                    Ctlraddr = Val(txtCtlrAddr.Text)
                    Call GPIB32Funcs.ibpad(bud, Ctlraddr)
                    If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then    'set controller address
                        Call gpiberr("ibpad error")
                        txtError.Text = RetMsg
                        txtError.Visible = True
                    Else
                        txtError.Visible = False
                        v = 1
                        Call GPIB32Funcs.ibsre(bud, v)              'assert REN
                        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
                            Call gpiberr("ibsre Error")
                            txtError.Text = RetMsg
                            txtError.Visible = True
                        Else
                            ckRen.CheckState = System.Windows.Forms.CheckState.Checked
                            txtError.Visible = False
                            frmTimeout.Enabled = True
                            
                            vtmo = GPIB32Funcs.T3s              'defautl to 3 second timeout
                            RadioButton4.Checked = True        'calls ibtmo
                            If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
                                Call gpiberr("ibtmo Error")
                                txtError.Text = RetMsg
                                txtError.Visible = True
                            Else
                                cmdSetCtlr.Enabled = True
                                txtCtlrAddr.Text = "0"
                                Call cmdFindLstn_Click(cmdFindLstn, New System.EventArgs()) 'find devices
                                If FoundFlg = 1 Then
                                    dev = founddev 'get found device number
                                    addr = founddev
                                    Device = founddev
                                    txtAddr.Text = Device
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub cmdGTL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdGTL.Click
        Dim gaddrlist(3) As Short

        txtError.Visible = False
        combCmd.Text = ""
        If FoundFlg = 0 Then
            txtResults.Text = "No devices found. Use Findlstn or enter and set a device address"
            txtError.Visible = False
            Beep()
            GoTo GTLexit
        End If

        gaddrlist(0) = addr
        gaddrlist(1) = GPIB32Funcs.NOADDR
        Call GPIB32Funcs.EnableLocal(BD, gaddrlist)                                'selected device clear
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("GTL Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "GTL sent to device" & Str(Device)
        End If

GTLexit: Call GPIBSignals()
    End Sub

    Private Sub _optTMO_4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged
        '9-100ms
        '10-300ms
        '11-1S
        '12-3S
        '13-10S
        '0-none

        If RadioButton1.Checked = True Then
            vtmo = 9
        ElseIf RadioButton2.Checked = True Then
            vtmo = 10
        ElseIf RadioButton3.Checked = True Then
            vtmo = 11
        ElseIf RadioButton4.Checked = True Then
            vtmo = 12
        ElseIf RadioButton5.Checked = True Then
            vtmo = 13
        ElseIf RadioButton6.Checked = True Then
            vtmo = 0
        End If

        txtError.Visible = False
        Call GPIB32Funcs.ibtmo(bud, vtmo)
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("ibtmo Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            If FoundFlg = 1 Then
                Call GPIB32Funcs.ibconfig(ud, GPIB32Funcs.IbcSPollTime, vtmo)
            End If
        End If
        Call GPIBSignals()
    End Sub

    Private Sub cmdLLO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdLLO.Click
        Dim gaddrlist(3) As Short

        txtError.Visible = False
        combCmd.Text = ""

        Call GPIB32Funcs.SendLLO(BD)                                'selected device clear
        If (GPIB32Funcs.ibsta And GPIB32Funcs.EERR) Then
            Call gpiberr("LLO Error")
            txtError.Text = RetMsg
            txtError.Visible = True
        Else
            txtError.Visible = False
            txtResults.Text = "LLO sent to all devices"
        End If

LLOexit: Call GPIBSignals()
    End Sub

End Class